#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUFFER_SIZE 256 // 1s̍ő吔
#define DICT_SIZE 100 // pPƓ{̑΂̍ő吔

char *usage[] = {
"O",
"   11dict - ",
"",
"   11dict t@C pP",
"",
"   ̃vÓA",
"   pPƓ{̏ꂽt@Cit@CjA",
"   ͂ꂽpP̓{\̂łB",
"t@C̗",
"   dictionary ",
"   English p",
"   foreign O",
"   home ",
"   end I",
"",
"   _",
"   Copyright (C) 1994,2018 by Hiroshi Yuki.",
NULL,
};

// P̑΂i[\̂̐錾
#define ENGLISH_SIZE 50 // pPi[z̑傫
#define JAPANESE_SIZE 50 // ai[z̑傫
typedef struct word {
    char english[ENGLISH_SIZE];     // pP
    char japanese[JAPANESE_SIZE];     // a
} PAIR;

PAIR dict[DICT_SIZE];
int dict_size = 0;

// vg^Cv錾
int main(int argc, char *argv[]);
int input_dict(FILE *fp);

int main(int argc, char *argv[])
{
    FILE *fp; // t@C

    // R}hC̉
    if (argc != 3) {
        for (int i = 0; usage[i] != NULL; i++) {
            printf("%s\n", usage[i]);
        }
        return 0;
    }

    // 
    char *dictfile = argv[1];

    // P
    char *english = argv[2];

    // t@C̃I[v
    fp = fopen(dictfile, "r");
    if (fp == NULL) {
        fprintf(stderr, "t@C %s ܂B\n",
            dictfile);
        return -1;
    }

    // t@Cǂݍ
    if (input_dict(fp) < 0) {
        fprintf(stderr,
            "t@C %s ̓ǂݍ݂ŃG[N܂B\n",
            dictfile);
        fclose(fp);
        return -1;
    }

    // PA\B
    for (int i = 0; i < dict_size; i++) {
        if (strcmp(dict[i].english, english) == 0) {
            printf("%s %s\n", dict[i].english, dict[i].japanese);
        }
    }

    return 0;
}

// ֐ input_dict ́At@Cf[^ǂݍށB
// ǂݍ񂾃f[^͑ϐdict[]dict_sizeɔfB
// 
//      FILE *fp ̓t@C
// ߂l
//      Ȃǂݍ񂾒P΂̐i0ȏjԂB
//      ُȂ-1ԂB
int input_dict(FILE *fp)
{
    char buffer[BUFFER_SIZE];
    char english_buffer[BUFFER_SIZE];
    char japanese_buffer[BUFFER_SIZE];

    // ̓ǂݍ
    dict_size = 0; // i[ĂP̐
    while (fgets(buffer, BUFFER_SIZE, fp) != NULL) {
        if (dict_size >= DICT_SIZE) {
            fprintf(stderr, "Pꐔ܂iő %d jB\n",
                DICT_SIZE);
            fclose(fp);
            return -1;
        }

        // ֐ sscanf găf[^
        int num = sscanf(buffer, "%s %s\n",
            english_buffer,
            japanese_buffer);
        if (num != 2) {
            fprintf(stderr, "%d sڂŌ`Ă܂B\n",
                dict_size + 1);
            fprintf(stderr, "%s\n", buffer);
            return -1;
        }

        // `FbNăI[o[t[h
        if (strlen(english_buffer) + 1 > ENGLISH_SIZE) {
            fprintf(stderr, "%d sڂ̉pP͒܂B",
                dict_size + 1);
            fprintf(stderr, "iő %d oCgj\n",
                ENGLISH_SIZE - 1);
            fprintf(stderr, "%s\n", english_buffer);
            return -1;
        }

        // pPRs[
        strcpy(dict[dict_size].english, english_buffer);

        // `FbNăI[o[t[h
        if (strlen(japanese_buffer) + 1 > JAPANESE_SIZE) {
            fprintf(stderr, "%d sڂ̓{͒܂B",
                dict_size + 1);
            fprintf(stderr, "iő %d oCgj\n",
                JAPANESE_SIZE - 1);
            fprintf(stderr, "%s\n", japanese_buffer);
            return -1;
        }

        // {Rs[
        strcpy(dict[dict_size].japanese, japanese_buffer);

        // P΂̐XV
        dict_size++;
    }

    return dict_size;
}
