#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUFFER_SIZE 1024

int main(int argc, char *argv[]);
void print_usage(void);

int main(int argc, char *argv[])
{
    if (argc != 3) {
        printf("gp@F%s ̓t@C o̓t@C\n", argv[0]);
        print_usage();
        return -1;
    }

    char *infile = argv[1];
    char *outfile = argv[2];

    printf("̓t@C: %s\n", infile);
    printf("o̓t@C: %s\n", outfile);

    FILE *infp = fopen(infile, "r");
    if (infp == NULL) {
        printf("t@C %s ܂B\n", infile);
        return -1;
    }

    FILE *outfp = fopen(outfile, "w");
    if (outfp == NULL) {
        printf("t@C %s ܂B\n", outfile);
        fclose(infp);
        return -1;
    }

    long linenumber = 1L;
    char buffer[BUFFER_SIZE];
    while (fgets(buffer, BUFFER_SIZE, infp) != NULL) {
        fprintf(outfp, "%08ld: %s", linenumber, buffer);
        linenumber++;
    }

    if (fclose(outfp)) {
        printf("t@C %s ̃N[YŃG[N܂B\n", outfile);
        fclose(infp);
        return -1;
    }

    if (fclose(infp)) {
        printf("t@C %s ̃N[YŃG[N܂B\n", infile);
        return -1;
    }

    return 0;
}

// gp@̕\
void print_usage(void)
{
    printf("es̐擪ɍsԍtďo͂܂B\n");
    printf("1s̍őTCY%doCgłB\n", BUFFER_SIZE);
}
