#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUFFER_SIZE 512 // 1s̃TCY
#define MAX_NAME    50  // i[z̃TCY
#define MAX_STUDENT 100 // ő̊w
#define MAX_TEN     5   // Ȑ

// gp@
char *usage[] = {
"O",
"   12stats - ȒPя",
"",
"   12stats ̓t@C [o̓t@C]",
"",
"   vO 12stats ́A",
"   ̓t@C琶k̖OƊeȂ̓_󂯎A",
"   яɕׂAϓ_߂肵āAʂo̓t@Cɏo܂B",
"   o̓t@Cw肳ĂȂꍇɂ́AWo͂ɏo͂܂B"
"",
"   уf[^͌lƂ1sɂ܂Ƃ߂ďA珇ɁA",
"       <oȔԍ> <> <_1> <_2> <_3> <_4> <_5>",
"   ̏ŋL܂B",
"͗",
"       101 Ԏq 65 90 100 80 73",
"       102 an 82 75 63 21 45",
"       103 ɓ 74 31 41 59 38",
"o",
"   EoȔԍ̖",
"   ESȂ̍v_ɂ鐬яʕ\Aϓ_Eō_EŒ_",
"   Ev_̕",
"",
"   _",
"   Copyright (C) 1993,2018 by Hiroshi Yuki.",
NULL,
};

// w\\
typedef struct student {
    int id;               // oȔԍ
    char name[MAX_NAME];  // 
    int ten[MAX_TEN];     // ȂƂ̓_
    double total;         // Ȃ̍v_
} STUDENT;

// f[^\\
typedef struct data {
    int size;                     // w
    STUDENT student[MAX_STUDENT]; // w̔z
} DATA;

// vg^Cv錾
int main(int argc, char *argv[]);
int input_data(FILE *fp, DATA *data);
void sort_by_id(DATA *data);
void sort_by_total(DATA *data);
void swap_student(STUDENT *p, STUDENT *q);
void fprint_data(FILE *fp, DATA *data);
void fprint_stat(FILE *fp, DATA *data);
void print_usage(void);

// ̓t@Cw̃f[^ǂݍŏ
int main(int argc, char *argv[])
{
    DATA data; // f[^i[ϐ

    // R}hC̉͂ƃt@C̃I[v
    if (argc != 2 && argc != 3) {
        print_usage();
        return 0;
    }

    FILE *infp = fopen(argv[1], "r");
    if (infp == NULL) {
        fprintf(stderr, "̓t@C %s ܂B\n", argv[1]);
        return -1;
    }

    FILE *outfp = stdout;
    if (argc == 3) {
        outfp = fopen(argv[2], "w");
        if (outfp == NULL) {
            fprintf(stderr, "o̓t@C %s 쐬ł܂B\n", argv[2]);
            fclose(infp);
            return -1;
        }
    }

    // f[^ǂݍ
    if (input_data(infp, &data) < 0) {
        fprintf(stderr, "f[^ǂݍ݂ŃG[N܂B\n");
        return -1;
    }

    // w\
    fprintf(outfp, "== w ==\n");
    fprintf(outfp, "%d l\n", data.size);
    fprintf(outfp, "\n");

    // oȔԍŕבւA\
    fprintf(outfp, "== oȔԍ̖ ==\n");
    sort_by_id(&data);
    fprint_data(outfp, &data);
    fprintf(outfp, "\n");

    // v_ŕבւA\
    fprintf(outfp, "== v_ɂ鐬яʕ\ ==\n");
    sort_by_total(&data);
    fprint_data(outfp, &data);
    fprintf(outfp, "\n");

    // ϓ_Eō_EŒ_\B
    fprintf(outfp, "== ϓ_Eō_EŒ_ ==\n");
    fprint_stat(outfp, &data);
    fprintf(outfp, "\n");

    if (fclose(outfp)) {
        printf("o̓t@C̃N[YŃG[N܂B\n");
        fclose(infp);
        return -1;
    }

    if (fclose(infp)) {
        printf("̓t@C̃N[YŃG[N܂B\n");
        return -1;
    }

    return 0;
}

// ֐ input_data ́At@Cf[^ǂݍށB
// 
//      FILE *infp ̓t@C
//      DATA *dp ǂݍ񂾃f[^i[\̂ւ̃|C^
// ߂l
//      펞́Aǂݍ񂾊wi0ȏjԂB
//      ُ펞́A-1ԂB
int input_data(FILE *infp, DATA *dp)
{
    char buffer[BUFFER_SIZE];
    char name_buffer[BUFFER_SIZE];
    int n = 0; // ݏĂw

    while (fgets(buffer, BUFFER_SIZE, infp) != NULL) {
        if (n >= MAX_STUDENT) {
            fprintf(stderr, "w܂(ő %d l)\n", MAX_STUDENT);
            return -1;
        }

        // t@Cǂݍ񂾊wf[^wւ̃|C^
        STUDENT *sp = &dp->student[n];

        // ֐sscanfgăf[^
        int num = sscanf(buffer, "%d %s %d %d %d %d %d\n", 
              &sp->id,
              &name_buffer[0],
              &sp->ten[0],
              &sp->ten[1],
              &sp->ten[2],
              &sp->ten[3],
              &sp->ten[4]);
        if (num != 7) {
            fprintf(stderr, "%d sڂŌ`Ă܂B\n",
                n + 1);
            fprintf(stderr, "%s\n", buffer);
            return -1;
        }

        // ̒`FbNăI[o[t[h
        if (strlen(name_buffer) + 1 > MAX_NAME) {
            fprintf(stderr, "%d sڂ̖O͒܂",
                n + 1);
            fprintf(stderr, "iő %d oCgj\n",
                MAX_NAME - 1);
            fprintf(stderr, "%s\n", name_buffer);
            return -1;
        }

        // Rs[
        strcpy(sp->name, name_buffer);

        // w̋ȍv_vZ
        sp->total = 0;
        for (int i = 0; i < MAX_TEN; i++) {
            sp->total += sp->ten[i];
        }

        // w̍XV
        n++;
    }

    // w
    dp->size = n;

    // wԂ
    return dp->size;
}

// ֐ swap_student STUDENT
void swap_student(STUDENT *p, STUDENT *q)
{
    STUDENT s = *p;
    *p = *q;
    *q = s;
}

// ֐ sort_by_id ͏oȔԍŕבւsB
void sort_by_id(DATA *dp)
{
    for (int i = 0; i < dp->size - 1; i++) {
        STUDENT *sp1 = &dp->student[i]; // iԖڂ̊w
        for (int j = i + 1; j < dp->size; j++) {
            STUDENT *sp2 = &dp->student[j]; // jԖڂ̊w
            if (sp1->id > sp2->id) { // oȔԍr
                swap_student(sp1, sp2);
            }
        }
    }
}

// ֐ sort_by_total ͍v_ŕבւsB
void sort_by_total(DATA *dp)
{
    for (int i = 0; i < dp->size - 1; i++) {
        STUDENT *sp1 = &dp->student[i]; // iԖڂ̊w
        for (int j = i + 1; j < dp->size; j++) {
            STUDENT *sp2 = &dp->student[j]; // jԖڂ̊w
            if (sp1->total < sp2->total) { // v_r
                swap_student(sp1, sp2);
            }
        }
    }
}

// ֐ fprint_data ̓f[^\B
void fprint_data(FILE *fp, DATA *data)
{
    for (int n = 0; n < data->size; n++) {
        STUDENT *sp = &data->student[n];

        // A
        fprintf(fp, "%3d) ", n + 1);
        // _
        for (int i = 0; i < MAX_TEN; i++) {
            fprintf(fp, "%3d ", sp->ten[i]);
        }
        // oȔԍ
        fprintf(fp, "oȔԍ %3d ", sp->id);
        // v_
        fprintf(fp, "v_ %0.1f ", sp->total);
        // ϓ_
        fprintf(fp, "ϓ_ %0.1f ", sp->total / MAX_TEN);
        // 
        fprintf(fp, " %s", sp->name);
        fprintf(fp, "\n");
    }
}

// ֐ fprint_stat() ́AȂƂ̕ϓ_Eō_EŒ_vZA
// \B܂v_̕ς\B
void fprint_stat(FILE *fp, DATA *data)
{
    int max[MAX_TEN];   // ȂƂ̍ō_
    int min[MAX_TEN];   // ȂƂ̍Œ_
    double ten[MAX_TEN];    // ȂƂ̕ϓ_
    double total;   // v_̕ϓ_
    STUDENT *sp;

    // 0 Ԗڂ̊w̃f[^ŏ
    sp = &data->student[0];
    for (int i = 0; i < MAX_TEN; i++) {
        max[i] = sp->ten[i];
        min[i] = sp->ten[i];
        ten[i] = sp->ten[i];
    }
    total = sp->total;

    // vvZ
    for (int n = 1; n < data->size; n++) {
        sp = &data->student[n];
        for (int i = 0; i < MAX_TEN; i++) {
            if (max[i] < sp->ten[i]) {
                max[i] = sp->ten[i];
            }
            if (min[i] > sp->ten[i]) {
                min[i] = sp->ten[i];
            }
            ten[i] += sp->ten[i];
        }
        total += sp->total;
    }

    // ʂ̏o
    for (int i = 0; i < MAX_TEN; i++) {
        fprintf(fp, " %d ", i + 1);
        fprintf(fp, "ō_ %3d ", max[i]);
        fprintf(fp, "Œ_ %3d ", min[i]);
        fprintf(fp, "ϓ_ %0.1f\n", ten[i] / data->size);
    }
    fprintf(fp, "v_̕ %0.1f\n", total / data->size);
}

// gp@̕\
void print_usage(void)
{
    for (int i = 0; usage[i] != NULL; i++) {
        printf("%s\n", usage[i]);
    }
}
